<template>
  <v-card class="pt-4">
    <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-smartphone' : 'dialog-content-scrollerd'">
      <v-form ref="form" @submit.prevent="validarFormulario">
        <v-select
          v-model="formProducto.tipo"
          :items="tipo"
          label="Tipo"
          item-value="id"
          item-text="label"
          :rules="rules.nombre"
          required
          color="accent"
          autofocus
        />
        <v-text-field
          v-model="formProducto.codigo"
          label="Código"
          type="text"
          :rules="rules.nombre"
          required
          color="accent"
        />
        <v-text-field
          v-model="formProducto.nombre"
          :label="formProducto.tipo === 4 ? 'Servicio' : formProducto.tipo === 2 ? 'Vacuna' : formProducto.tipo === 3 ? 'Medicamento' : 'Producto'"
          type="text"
          :rules="rules.nombre"
          required
          color="accent"
        />
        <v-text-field
          v-if="formProducto.tipo === 2 || formProducto.tipo === 3"
          v-model="formProducto.edad_aplicacion"
          label="Edad de aplicación"
          type="number"
          :rules="rules.nombre"
          required
          color="accent"
        />
        <v-text-field
          v-model="formProducto.precio_ingreso"
          label="Precio de ingreso"
          type="number"
          :rules="rules.nombre"
          required
          color="accent"
        />
        <v-text-field
          v-if="formProducto.tipo !== 4"
          v-model="formProducto.stock"
          label="Stock"
          type="number"
          :rules="rules.nombre"
          required
          color="accent"
        />
        <v-menu
          v-if="formProducto.tipo !== 4"
          ref="menufecha"
          v-model="menufecha"
          :close-on-content-click="false"
        >
          <template #activator="{ on }">
            <v-text-field
              v-model="fechaVencimiento"
              label="Fecha de vencimiento"
              placeholder="Haga Click Aquí"
              prepend-icon="fal fa-calendar-minus"
              readonly
              color="accent"
              v-on="on"
            />
          </template>
          <v-date-picker
            ref="picker"
            v-model="formProducto.fecha_vencimiento"
            locale="es-es"
            min="1930-01-01"
            color="accent"
            @change="menufecha=false"
          />
        </v-menu>
        <v-btn v-if="formProducto.tipo !== 4" class="mb-2" block @click="dialogListaProveedor=true">
          Seleccionar proveedor
        </v-btn>
        <v-alert
          v-if="proveedorActual"
          text
          dense
          color="accent"
          border="left"
        >
          <v-row align="center">
            <v-col class="grow">
              <tr>Nombre: {{ proveedorActual.nombre }}</tr>
              <tr>Ciudad: {{ proveedorActual.ciudad }}</tr>
              <tr>Dirección: {{ proveedorActual.direccion }}</tr>
            </v-col>
          </v-row>
        </v-alert>
      </v-form>
    </v-card-text>

    <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
      <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog()">
        Cerrar
      </v-btn>
      <v-spacer />
      <v-btn v-if="!isEditar" class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Agregar
      </v-btn>
      <v-btn v-else class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Modificar
      </v-btn>
    </v-card-actions>
    <v-dialog v-model="dialogListaProveedor" width="1400" :fullscreen="$vuetify.breakpoint.smAndDown">
      <v-card>
        <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-unico' : 'dialog-content-scrollerd'">
          <lista-proveedores v-if="dialogListaProveedor" :seleccionable="true" :proveedor-seleccionado="proveedorActual" @selectedProveedor="actualizarProveedor" />
        </v-card-text>
        <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
          <v-btn class="elevation-2 font-weight-light" @click="dialogListaProveedor = false">
            Cerrar
          </v-btn>
          <v-spacer />
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-card>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue } from 'vue-property-decorator'
import moment from 'moment'
import AppToast from '~/core/utils/AppToast'
import { AppStore } from '~/store/AppStore'
import { Producto } from '~/core/models/producto'
import { ProductosStore } from '~/store/ProductosStore'
import ListaProveedores from '~/components/proveedores/listaProveedores.vue'
import { Proveedor } from '~/core/models/proveedor'
import { EnumsHelpers } from '~/core/helpers/EnumsHelpers'
import { getTipoProducto, TipoProductoEnum } from '~/core/enums/TipoProductoEnum'
    @Component({
      components: { ListaProveedores }
    })
export default class formProductos extends Vue {
        @Ref('form') formulario;
        @Prop({ default: null }) producto!:Producto;

      proveedorActual:Proveedor = null;
      dialogListaProveedor:boolean =false;
      menufecha:boolean = false;

      formProducto:Producto = {
        nombre: '',
        precio_ingreso: null,
        codigo: '',
        tipo: null
      };

        rules = {
          nombre: [
            v => !!v || 'Campo requerido'
          ]
        };

        get isEditar () {
          return this.producto
        }

        get tipo () {
          return EnumsHelpers.enumtolist(TipoProductoEnum).map(p => getTipoProducto(p.id))
        }

        get fechaVencimiento ():string {
          return this.formProducto.fecha_vencimiento ? moment(this.formProducto.fecha_vencimiento).format('DD/MM/YYYY') : ''
        }

        mounted () {
          if (this.isEditar) {
            this.cargarFormConProducto()
          }
        }

        private cargarFormConProducto () {
          Object.assign(
            this.formProducto,
            this.producto
          )
        }

        actualizarProveedor (proveedor:Proveedor) {
          this.dialogListaProveedor = false
          if (proveedor) {
            this.proveedorActual = proveedor
            this.formProducto.proveedores_idproveedores = proveedor.idproveedores
          } else {
            this.proveedorActual = null
            this.formProducto.proveedores_idproveedores = null
          }
        }

        cerrarDialog () {
          this.$emit('onClose')
        }

        validarFormulario () {
          if (this.formulario.validate()) {
            if (this.formProducto.proveedores_idproveedores) {
              if (this.isEditar) {
                this.modificarProducto()
              } else {
                this.guardarProducto()
              }
            } else if (this.formProducto.tipo === 4) {
              if (this.isEditar) {
                this.modificarProducto()
              } else {
                this.guardarProducto()
              }
            } else {
              AppToast.error('Por favor seleccione un proveedor')
            }
          } else {
            AppToast.error('Campos inválidos')
          }
        }

        private async guardarProducto () {
          AppStore.SHOW_LOADING('Guardando Producto')
          try {
            await ProductosStore.registrarProductos(this.formProducto)
            this.cerrarDialog()
            AppToast.success('Producto registrado')
          } catch (e) {
          }
          AppStore.HIDE_LOADING()
        }

        private async modificarProducto () {
          AppStore.SHOW_LOADING('Guardando Producto')
          try {
            await ProductosStore.modificarProducto(this.formProducto)
            this.cerrarDialog()
            AppToast.success('Producto registrado')
          } catch (e) {
          }
          AppStore.HIDE_LOADING()
        }
}
</script>

<style lang="scss">

</style>
